//*****************************************
// IV-27 VFD Clock Program Mega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
//
// File Name:Timer.c
//
// 2016/07/05
//  huPWQbknbj̃\[XύXAtBg쓮ǉĂhu|QPpƂ
// 2018/02/13
//  huQPQbknbj̃\[XύXA𑝂₵Ăhu|QVpƂ
//
//  2015/12/29 New(TAB4)  Taishi
//  2016/07/05 modify     Taishi  IV-21pɕύX{tBg쓮ǉ
//  2016/08/13 modify     Taishi  [Ver 1.1] QSu kdc_ł
//  2018/02/13 New(TAB4)  Taishi  [Ver 0.1] iv_21_clock [Ver 1.1]iv_27clock
//  2018/07/31 modify     Taishi  [Ver 1.11] tBg`𗬋쓮ɂ
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>


#include	"iv27_clock.h"
#include	"disp_7seg_iv27.h"
#include	"Ad_conv.h"
#include	"Timer.h"


unsigned char	tim_for_10ms;					// 10mSPʂJE^[
unsigned char	tim_for_1sec;					// PbPʂJE^[
unsigned char	tim_10ms_led;					// kdcpPOrPʃ^C}[
unsigned char	tim_10ms_maru;					// ۗpPOrPʃ^C}[@|P
unsigned char	tim_10ms_sw;					// rvhsbgpPOrPʃ^C}[
unsigned char	tim_10ms_swl_length;			// XCb`pԂPOrPʃ^C}[@|P
unsigned char	tim_10ms_swl_continue;			// XCb`pAPOrPʃ^C}[@|P
unsigned char	tim_10ms_swr_length;			// EXCb`pԂPOrPʃ^C}[@|P
unsigned char	tim_10ms_swr_continue;			// EXCb`pAPOrPʃ^C}[@|P
unsigned char	tim_10ms_sblink;				// \_ŗpPOrPʃ^C}[@|P
unsigned char	tim_10ms_infrared;				// ԊORfqpPOrPʃ^C}[
unsigned char	tim_1s_no_key_timeup;			// L[͂Ȃ̃^CAbvp
unsigned char	count_1s_disp;					// t[̂PbJE^[
unsigned char	tim_filament;					// 20180731 tBgp̃^C}[



// **********************************************************
// ************************ Timer 2 *************************
// **********************************************************
// 8MHz-- 1mS Interrupt
//#define	COUNT_1MS		125										// 1mS (8uS x 125 = 1mS)
//#define	D_TCCR2B	((1 << CS22) | (0 << CS21) | (0 << CS20))	// Timer Start (8MHz/64= 125kHz, 8uS)

// 8MHz-- 500uS Interrupt
#define	COUNT_500uS		125										// 500uS  (4uS x 125 = 500uS)
#define	D_TCCR2B	((0 << CS22) | (1 << CS21) | (1 << CS20))	// Timer Start (8MHz/32= 250kHz, 4uS)

// 8MHz-- 200uS Interrupt
#define	COUNT_200uS		50										// 200uS  (4uS x 50 = 200uS)
#define	D_TCCR2B	((0 << CS22) | (1 << CS21) | (1 << CS20))	// Timer Start (8MHz/32= 250kHz, 4uS)

//*****************************************
// Timer2 Initial
//  200uS 荞݂ɐݒ肷
//*****************************************
void	Timer2_init(void)
{
	TCCR2B = 0;											// Timer Stop
	TCNT2 = 0;											// Timer2 Count Set to ZERO
	TCCR2A = ((1 << WGM21) | (0 << WGM20));				// A Comper Match, Dont Output Timer2 Signal
	OCR2A  = COUNT_200uS;								// 200uS
	TCCR2B = D_TCCR2B;									// Timer Start
	TIMSK2 |= (1 << OCIE2A);							// A Comper Match Interrupt Enable

	tim_for_10ms = 50;									// 10mSPʂJE^[
	tim_for_1sec = 0;									// PbPʂJE^[
	tim_10ms_led = 0;									// kdcpPOrPʃ^C}[
	tim_10ms_maru = 0;									// ۗpPOrPʃ^C}[@|P
	tim_10ms_sw = 0;									// rvhsbgpPOrPʃ^C}[
	tim_10ms_swl_length = 0;							// XCb`pԂPOrPʃ^C}[@|P
	tim_10ms_swl_continue = 0;							// XCb`pAPOrPʃ^C}[@|P
	tim_10ms_swr_length = 0;							// EXCb`pԂPOrPʃ^C}[@|P
	tim_10ms_swr_continue = 0;							// EXCb`pAPOrPʃ^C}[@|P
	tim_10ms_sblink = 0;								// \_ŗpPOrPʃ^C}[@|P
	tim_10ms_infrared = 0;								// ԊORfqpPOrPʃ^C}[
	count_1s_disp = 0;									// t[̂PbJE^[
	tim_filament = 5;									// 20180731 tBgp̃^C}[
}
//*****************************************
// Timer2 Close
//  Timer2 ̎gp߂
//*****************************************
void	Timer2_close(void)
{
	TCCR2B = 0;											// Timer Stop
	TCNT2 = 0;											// Timer2 Count Set to ZERO
	TCCR2A = 0;											// Dont Output Timer2 Signal
	TIMSK2 = 0;											// Interrupt Disable

}
//***************************
// Timer2 Comper Match A Interrupt
//
//  200uS 
//***************************
ISR	(TIMER2_COMPA_vect)	
{
	tim_for_10ms--;								// 10mSPʂJE^[
	if(tim_for_10ms == 0){						// 10mSo߂
		tim_for_10ms = 50;						// 10mSPʂJE^[
		tim_for_1sec++;
		if(100 <= tim_for_1sec){				// Pbo
			tim_for_1sec = 0;
			count_1s_disp++;					// t[̂PbJE^[
		}

		if(tim_10ms_led != 0){
			tim_10ms_led--;						// kdcpPOrPʃ^C}[@|P
		}

		if(tim_10ms_maru != 0){
			tim_10ms_maru--;					// ۗpPOrPʃ^C}[@|P
		}

		if(tim_10ms_sw != 0){
			tim_10ms_sw--;						// rvhsbgpPOrPʃ^C}[@|P
		}

		if(tim_10ms_swl_continue != 0){
			tim_10ms_swl_continue--;			// XCb`pAPOrPʃ^C}[@|P
		}

		if(tim_10ms_swl_length != 0){
			tim_10ms_swl_length--;				// XCb`pԂPOrPʃ^C}[@|P
		}

		if(tim_10ms_swr_continue != 0){
			tim_10ms_swr_continue--;			// EXCb`pAPOrPʃ^C}[@|P
		}

		if(tim_10ms_swr_length != 0){
			tim_10ms_swr_length--;				// EXCb`pԂPOrPʃ^C}[@|P
		}

		if(tim_10ms_sblink != 0){
			tim_10ms_sblink--;					// \_ŗpPOrPʃ^C}[@|P
		}

		if(tim_10ms_infrared != 0){
			tim_10ms_infrared--;				// ԊORfqpPOrPʃ^C}[@|P
		}

//		ad7_set_data();							// A/D 7 Set A/D data to Data Buffer

//20190731		proc_filament();						//  tBg̑
	}

	tim_filament--;								// 20180731 tBgp̃^C}[
	if(tim_filament == 0){						// 20180731 tBgp̃^C}[
		tim_filament = 5;						// 20190731 V傫ƕ\
		proc_filament();						// 20189731 tBg̑
	}

	disp_7seg();								//  VZO̕\
	ad67_set_data();							// A/D 6&7 Set A/D data to Data Buffer
}

//***************************
// ԃL[͂̔f
//@ on:1 = L[LA@0= ^CAbṽ`FbN
//  ߂l@O@^CAbvĂȂ
//@@O@^CAbv
//***************************
unsigned char	proc_no_key_timeup(unsigned char on)
{
	unsigned char	r=0;

	if (on == 1){
		tim_1s_no_key_timeup = TIM_DISP_RETURN;		// ^CAbv̎Ԑݒ
	}else{
		if(tim_1s_no_key_timeup == 0){				// ^CAbv
			r = 0xff;
		}
	}
	return(r);
}
