//*****************************************
// IV-27 VFD Clock Program Mega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
//
// File Name:port_bit.c
//
// 2016/07/05
//  huPWQbknbj̃\[XύXAtBg쓮ǉĂhu|QPpƂ
// 2018/02/13
//  huQPQbknbj̃\[XύXA𑝂₵Ăhu|QVpƂ
//
//  2015/12/29 New
//  2016/02/09 modify     Taishi  vݒ莞̒l̋ύX
//  2016/07/05 modify     Taishi  IV-21pɕύX{tBg쓮ǉ
//  2018/02/13 New(TAB4)  Taishi  [Ver 0.1] iv_21_clock [Ver 1.1]iv_27clock
//*****************************************

#include	<avr/io.h>

#include	"iv27_clock.h"
#include	"timer.h"
#include	"Ad_conv.h"
#include	"port_bit.h"

#define		SWL_ON_VALUE	512					// `^cl̒l̎́@XCb`nmƔf
unsigned char	sw[4];							// SW[1] Ɍ݂̏ԁAĂ镨'1'̏ԁA SW[2] ɉꂽuԂ'1'̏ԁA SW[3] ɗꂽuԂ'1'̏
static	unsigned char	old_sw;
static	unsigned char	sw_continue_count;
//***************************
//@XCb`̏ݒ
//***************************
void	sw_init(void)
{
	DDRD  &= ~(1 << DDD3);					// Port-D Bit3 : Intput
	PORTD |= (1 << PD3);					// PD3 Pullup
	sw_continue_count = 0;
}
//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
//  Timer2 ̊荞݂gpĂԂKv
// SW_LEFT `^clɂnm^nee߂(TPQȂnmj
// @̈ `^cȔ͎Oɍs
//***************************
void	get_sw(void)
{
	unsigned char	uc;
	unsigned short	us;

	if(tim_10ms_sw == 0){
		tim_10ms_sw = 3;									// ROrԊu
		uc = ((~PIND) & SW_RIGHT);							// ]ĉEXCb`f[^擾
		us = ad6_get_data();								// A/D 6 Get A/D data
		if(us < SWL_ON_VALUE){								//  XCb`nm̎
			uc |= SW_LEFT;
		}
		if (old_sw == uc){									// OƓf[^̎
			sw[0] = sw[1];
			sw[1] = uc;
			sw[2] = ((sw[0] ^ sw[1]) & sw[1]);				// ꂽXCb`f[^
			sw[3] = ((sw[0] ^ sw[1]) & ~sw[1]);				// ꂽXCb`f[^
		}else{
			sw[2] = 0;
			sw[3] = 0;
		}
		old_sw = uc;										// Of[^ɓ
	}else{
		sw[2] = 0;
		sw[3] = 0;
	}
}
#define			TMR_LONG			100			// 10mSx100=1Sec ̎Ԗ͒ZԂƂ
#define			TMR_CONTIMUE		100			// 10mSx100=1Sec ꑱ@̊ԊuŁuSWR_ON_CONTINUEvɂȂ
#define			TMR_CONTIMUE2		50			// 10mSx50=500mS ꑱ̂Qxڈȍ~́uSWR_ON_CONTINUEvo^C~OɂȂ
#define			TML_LONG			100			// 10mSx100=1Sec ̎Ԗ͒ZԂƂ
#define			TML_CONTIMUE		100			// 10mSx100=1Sec ꑱ@̊ԊuŁuSWL_ON_CONTINUEvɂȂ
#define			TML_CONTIMUE2		50			// 10mSx50=500mS ꑱ̂Qxڈȍ~́uSWL_ON_CONTINUEvo^C~OɂȂ
//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
//  Timer2 ̊荞݂gpĂԂKv
//***************************
unsigned short	get_action_sw(void)
{
	unsigned short	uc=0;

	get_sw();												//@XCb`Ԃ

	// XCb`
	if((sw[2] & SW_LEFT) != 0){								// XCb`nm̏uԂ̎
		uc |= (SWL_ON_NOW | SWL_ON);
		tim_10ms_swl_continue = TML_CONTIMUE;
		tim_10ms_swl_length = TML_LONG;
		sw_continue_count = 1;
	}else if((sw[1] & SW_LEFT) != 0){						// XCb`nm̎
		uc |= SWL_ON;
		if(tim_10ms_swl_continue == 0){						// ꑱo^C~O̎
			uc |= SWL_ON_CONTINUE;
			if(sw_continue_count < 2){
				sw_continue_count++;
				tim_10ms_swl_continue = TML_CONTIMUE;
			}else{
				tim_10ms_swl_continue = TML_CONTIMUE2;
			}
		}
	}else if((sw[3] & SW_LEFT) != 0){						// XCb`ꂽuԂ̎
		if(tim_10ms_swl_length == 0){						// ꂽԂ
			uc |= SWL_OFF_LONG;
		}else{												// ꂽԂZ
			uc |= SWL_OFF_SHORT;
		}
		tim_10ms_swl_continue = 0;
		tim_10ms_swl_length = 0;
		sw_continue_count = 0;
	}else if((sw[1] & SW_LEFT) == 0){						// XCb`nee̎
		tim_10ms_swl_continue = 0;
		tim_10ms_swl_length = 0;
		sw_continue_count = 0;
	}

	// EXCb`
	if((sw[2] & SW_RIGHT) != 0){							// EXCb`nm̏uԂ̎
		uc |= (SWR_ON_NOW | SWR_ON);
		tim_10ms_swr_continue = TMR_CONTIMUE;
		tim_10ms_swr_length = TMR_LONG;
		sw_continue_count = 1;
	}else if((sw[1] & SW_RIGHT) != 0){						// EXCb`nm̎
		uc |= SWR_ON;
		if(tim_10ms_swr_continue == 0){						// ꑱo^C~O̎
			uc |= SWR_ON_CONTINUE;
			if(sw_continue_count < 2){
				sw_continue_count++;
				tim_10ms_swr_continue = TMR_CONTIMUE;
			}else{
				tim_10ms_swr_continue = TMR_CONTIMUE2;
			}
		}
	}else if((sw[3] & SW_RIGHT) != 0){						// EXCb`ꂽuԂ̎
		if(tim_10ms_swr_length == 0){						// ꂽԂ
			uc |= SWR_OFF_LONG;
		}else{												// ꂽԂZ
			uc |= SWR_OFF_SHORT;
		}
		tim_10ms_swr_continue = 0;
		tim_10ms_swr_length = 0;
		sw_continue_count = 0;
	}else if((sw[1] & SW_RIGHT) == 0){						// EXCb`nee̎
		tim_10ms_swr_continue = 0;
		tim_10ms_swr_length = 0;
		sw_continue_count = 0;
	}

	return(uc);
}

//*****************************************
// XCb`@܂ŉiv[v
//  XCb`͂Ɋ荞݃^C}[gB
//  Timer2 ̊荞݂gpĂԂKv
//*****************************************
void	wait_key_off(void)
{
	while(1){											// rv܂ő҂
		get_action_sw();								//@XCb`Ԃ
		if( (sw[1] & (SW_LEFT | SW_RIGHT)) == 0 ){		// Ă鎞
			break;
		}
	}
}
//*****************************************
// EXCb`@܂ŉiv[v
//  EXCb`rbǵA`^Op^C}[Ɂ@荞݂͎gȂ
//  \tgEFA^C}[gp
//*****************************************
void	wait_swr_off(void)
{
	while(1){
		if((PIND & SW_RIGHT) == SW_RIGHT){
			delay_ms(100);												// 100mS Delay
			if((PIND & SW_RIGHT) == SW_RIGHT){
				break;													// {ɗꂽƂ
			}
		}
	}
}

//***************************
//@LED̏ݒ
//***************************
void	led_init(void)
{
//	DDRD  |= (1 << DDD0);					// Port-D Bit0 : Output
//	PORTD &= ~(1 << PD0);					// PD0 Low
	DDRD  |= (1 << DDD1);					// Port-D Bit1 : Output
	PORTD &= ~(1 << PD1);					// PD1 Low
}
//***************************
//@LEDON/OFF
//  F@OneeijAPnmi_j
//***************************
void	led_on_off(unsigned char on)
{
	if(on == 0){
//		PORTD &= ~(1 << PD0);					// PD0 Low
		PORTD &= ~(1 << PD1);					// PD1 Low
	}else{
//		PORTD |=  (1 << PD0);					// PD0 High
		PORTD |=  (1 << PD1);					// PD1 High
	}
}


