//*****************************************
// IV-27 VFD Clock Program Mega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
// File Name:set_rtc.c
//
// 2016/07/05
//  huPWQbknbj̃\[XύXAtBg쓮ǉĂhu|QPpƂ
// 2018/02/13
//  huQPQbknbj̃\[XύXA𑝂₵Ăhu|QVpƂB
//@@ԊORXCb`Ɠ
//
//  2016/04/26 New  Taishi  vݒ蕔 Rtc_DS3234.c 番
//  2016/07/05 modify     Taishi  IV-21pɕύX{tBg쓮ǉ
//  2018/02/13 New(TAB4)  Taishi  [Ver 0.1] iv_21_clock [Ver 1.1]iv_27clock
//*****************************************

#include	"iv27_clock.h"
#include	"Timer.h"
#include	"disp_7seg_iv27.h"
#include	"port_bit.h"
#include	"Rtc_DS3234.h"
#include	"infrared.h"

#include	"set_rtc.h"


//*****************************************
//  킹p̑S̕\
//*****************************************
static
void	disp_ymdmhs(void)
{
	set_7seg_data('-',0,0);
	set_7seg_data('-',0,1);
	set_7seg_data(gRTC_year >> 4,0,2);			// N\
	set_7seg_data(gRTC_year & 0x0f,1,3);
	set_7seg_data(gRTC_mon >> 4,0,4);			// \
	set_7seg_data(gRTC_mon & 0x0f,1,5);
	set_7seg_data(gRTC_day >> 4,0,6);			// \
	set_7seg_data(gRTC_day & 0x0f,1,7);
	set_7seg_data(gRTC_hou >> 4,0,8);			// \
	set_7seg_data(gRTC_hou & 0x0f,1,9);
	set_7seg_data(gRTC_min >> 4,0,10);			// \
	set_7seg_data(gRTC_min & 0x0f,1,11);
	set_7seg_data(gRTC_sec >> 4,0,12);			// b\
	set_7seg_data(gRTC_sec & 0x0f,0,13);

}
//*****************************************
// N킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static unsigned char	proc_set_year(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ye;
	unsigned char	ucif;
	unsigned short	us;
	unsigned char	r=0;

	ye = gRTC_year;
	set_7seg_data(ye >> 4,0,2);
	set_7seg_data(ye & 0x0f,1,3);

	tim_10ms_sblink = 0;									// _
	while(1){
		us = get_action_sw();								// XCb`Ԃ
		ucif = get_infrared_data();							// ԊORfqf[^
		if((us & (SWL_MASK | SWR_MASK)) == 0){				// XCb`ĂȂ
			us = trans_if_to_sw(ucif);						// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_sblink == 0){							// _Ń^C~O̎
			tim_10ms_sblink = 50;
			if((blk_stat==0)&&((us & SWL_ON) == 0)){		// ĂȂ ł̎
				blk_stat = 1;
				set_7seg_data(16,0,2);
				set_7seg_data(16,1,3);
			}else{
				blk_stat = 0;
				set_7seg_data(ye >> 4,0,2);
				set_7seg_data(ye & 0x0f,1,3);
			}
		}

		if(us != 0){										// ANVL鎞
			proc_no_key_timeup(1);							// L[͂L
			if((us & (SWL_ON_CONTINUE | SWL_ON_NOW)) != 0){	// select ꂽ@́@ꑱ
				ye++;
				if(9 < (ye & 0x0f)){						// X𒴂
					ye &= 0xf0;
					ye += 0x10;
				}
				if(0x99 < ye){
					ye = 0;
				}
			}else if((us & (SWR_OFF_SHORT | SWR_OFF_LONG)) != 0){	//  set Zꂽ ́@ꂽ
				if(gRTC_year == ye){						// lύXĂȂ
					r = 0;
				}else{
					gRTC_year = ye;
					rtc_write();							// RTC 
				}
				set_7seg_data(ye >> 4,0,2);
				set_7seg_data(ye & 0x0f,1,3);
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){					// ԃL[͂
			r = 0xff;
			break;
		}

		if(tim_10ms_led == 0){								// Ԍo߂
			if(ucif != 0){									// ԊORM
 				led_on_off(1);								// kdĉnm
				tim_10ms_led = 10;							// POOr^C}[d|
 			}else{
				led_on_off(0);
			}
		}

	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static unsigned char	proc_set_month(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mo;
	unsigned char	ucif;
	unsigned short	us;
	unsigned char	r=0;

	mo = gRTC_mon;
	set_7seg_data(mo >> 4,0,4);
	set_7seg_data(mo & 0x0f,0,5);

	tim_10ms_sblink = 0;									// _
	while(1){
		us = get_action_sw();								// XCb`Ԃ
		ucif = get_infrared_data();							// ԊORfqf[^
		if((us & (SWL_MASK | SWR_MASK)) == 0){				// XCb`ĂȂ
			us = trans_if_to_sw(ucif);						// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_sblink == 0){							// _Ń^C~O̎
			tim_10ms_sblink = 50;
			if((blk_stat==0)&&((us & SWL_ON) == 0)){		// ĂȂ ł̎
				blk_stat = 1;
				set_7seg_data(16,0,4);
				set_7seg_data(16,1,5);
			}else{
				blk_stat = 0;
				set_7seg_data(mo >> 4,0,4);
				set_7seg_data(mo & 0x0f,1,5);
			}
		}

		if(us != 0){										// ANVL鎞
			proc_no_key_timeup(1);							// L[͂L
			if((us & (SWL_ON_CONTINUE | SWL_ON_NOW)) != 0){	// select ꂽ@́@ꑱ
				mo++;
				if(9 < (mo & 0x0f)){						// X𒴂
					mo &= 0xf0;
					mo += 0x10;
				}
				if(0x12 < mo){
					mo = 1;
				}
			}else if((us & (SWR_OFF_SHORT | SWR_OFF_LONG)) != 0){	//  set Zꂽ ́@ꂽ
				if(gRTC_mon == mo){							// lύXĂȂ
					r = 0;
				}else{
					gRTC_mon = mo;
					rtc_write();							// RTC 
				}
				set_7seg_data(mo >> 4,0,4);
				set_7seg_data(mo & 0x0f,1,5);
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){					// ԃL[͂
			r = 0xff;
			break;
		}

		if(tim_10ms_led == 0){								// Ԍo߂
			if(ucif != 0){									// ԊORM
 				led_on_off(1);								// kdĉnm
				tim_10ms_led = 10;							// POOr^C}[d|
 			}else{
				led_on_off(0);
			}
		}

	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static unsigned char	proc_set_day(void)
{
	unsigned char	blk_stat=0;
	unsigned char	da;
	unsigned char	ucif;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	uru=0;
	unsigned char	syo=0;

	if(((((gRTC_year/16)*10)+(gRTC_year/16))/4) == 0){									// 邤N
		uru=1;
	}
	if((gRTC_mon == 0x04)||(gRTC_mon == 0x06)||(gRTC_mon == 0x09)||(gRTC_mon == 0x11)){	// ̌
		syo=1;
	}
	da = gRTC_day;
	set_7seg_data(da >> 4,0,6);
	set_7seg_data(da & 0x0f,1,7);


	tim_10ms_sblink = 0;									// _
	while(1){
		us = get_action_sw();								// XCb`Ԃ
		ucif = get_infrared_data();							// ԊORfqf[^
		if((us & (SWL_MASK | SWR_MASK)) == 0){				// XCb`ĂȂ
			us = trans_if_to_sw(ucif);						// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_sblink == 0){							// _Ń^C~O̎
			tim_10ms_sblink = 50;
			if((blk_stat==0)&&((us & SWL_ON) == 0)){		// ĂȂ ł̎
				blk_stat = 1;
				set_7seg_data(16,0,6);
				set_7seg_data(16,1,7);
			}else{
				blk_stat = 0;
				set_7seg_data(da >> 4,0,6);
				set_7seg_data(da & 0x0f,1,7);
			}
		}

		if(us != 0){										// ANVL鎞
			proc_no_key_timeup(1);							// L[͂L
			if((us & (SWL_ON_CONTINUE | SWL_ON_NOW)) != 0){	// select ꂽ@́@ꑱ
				da++;
				if(9 < (da & 0x0f)){						// X𒴂
					da &= 0xf0;
					da += 0x10;
				}
				if(syo == 1){								// ̌
					if(0x30 < da){
						da = 1;
					}
				}else if(gRTC_mon == 0x02){
					if(uru == 1){							// Q 邤N
						if(0x29 < da){
							da = 1;
						}
					}else{									// Q N
						if(0x28 < da){
							da = 1;
						}
					}
				}else{										// ̌
					if(0x31 < da){
						da = 1;
					}
				}
			}else if((us & (SWR_OFF_SHORT | SWR_OFF_LONG)) != 0){	//  set Zꂽ ́@ꂽ
				if(gRTC_day == da){							// lύXĂȂ
					r = 0;
				}else{
					gRTC_day = da;
					rtc_write();							// RTC 
				}
				set_7seg_data(da >> 4,0,6);
				set_7seg_data(da & 0x0f,1,7);
				break;										// I
			}
		}

		if (proc_no_key_timeup(0) == 0xff){					// ԃL[͂
			r = 0xff;
			break;
		}

		if(tim_10ms_led == 0){								// Ԍo߂
			if(ucif != 0){									// ԊORM
 				led_on_off(1);								// kdĉnm
				tim_10ms_led = 10;							// POOr^C}[d|
 			}else{
				led_on_off(0);
			}
		}

	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static unsigned char	proc_set_hour(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ho;
	unsigned char	ucif;
	unsigned short	us;
	unsigned char	r=0;

	ho = gRTC_hou;
	set_7seg_data(ho >> 4,0,8);
	set_7seg_data(ho & 0x0f,1,9);

	tim_10ms_sblink = 0;									// _
	while(1){
		us = get_action_sw();								// XCb`Ԃ
		ucif = get_infrared_data();							// ԊORfqf[^
		if((us & (SWL_MASK | SWR_MASK)) == 0){				// XCb`ĂȂ
			us = trans_if_to_sw(ucif);						// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_sblink == 0){							// _Ń^C~O̎
			tim_10ms_sblink = 50;
			if((blk_stat==0)&&((us & SWL_ON) == 0)){		// ĂȂ ł̎
				blk_stat = 1;
				set_7seg_data(16,0,8);
				set_7seg_data(16,1,9);
			}else{
				blk_stat = 0;
				set_7seg_data(ho >> 4,0,8);
				set_7seg_data(ho & 0x0f,1,9);
			}
		}

		if(us != 0){										// ANVL鎞
			proc_no_key_timeup(1);							// L[͂L
			if((us & (SWL_ON_CONTINUE | SWL_ON_NOW)) != 0){	// select ꂽ@́@ꑱ
				ho++;
				if(9 < (ho & 0x0f)){						// X𒴂
					ho &= 0xf0;
					ho += 0x10;
				}
				if(0x23 < ho){
					ho = 0;
				}
			}else if((us & (SWR_OFF_SHORT | SWR_OFF_LONG)) != 0){	//  set Zꂽ ́@ꂽ
				if(gRTC_hou == ho){							// lύXĂȂ
					r = 0;
				}else{
					gRTC_hou = ho;
					rtc_write();							// RTC 
				}
				set_7seg_data(ho >> 4,0,8);
				set_7seg_data(ho & 0x0f,1,9);
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){					// ԃL[͂
			r = 0xff;
			break;
		}

		if(tim_10ms_led == 0){								// Ԍo߂
			if(ucif != 0){									// ԊORM
 				led_on_off(1);								// kdĉnm
				tim_10ms_led = 10;							// POOr^C}[d|
 			}else{
				led_on_off(0);
			}
		}

	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static unsigned char	proc_set_minute(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mi;
	unsigned char	ucif;
	unsigned short	us;
	unsigned char	r=0;

	mi = gRTC_min;
	set_7seg_data(mi >> 4,0,10);
	set_7seg_data(mi & 0x0f,1,11);

	tim_10ms_sblink = 0;									// _
	while(1){
		us = get_action_sw();								// XCb`Ԃ
		ucif = get_infrared_data();							// ԊORfqf[^
		if((us & (SWL_MASK | SWR_MASK)) == 0){				// XCb`ĂȂ
			us = trans_if_to_sw(ucif);						// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_sblink == 0){							// _Ń^C~O̎
			tim_10ms_sblink = 50;
			if((blk_stat==0)&&((us & SWL_ON) == 0)){		// ĂȂ ł̎
				blk_stat = 1;
				set_7seg_data(16,0,10);
				set_7seg_data(16,1,11);
			}else{
				blk_stat = 0;
				set_7seg_data(mi >> 4,0,10);
				set_7seg_data(mi & 0x0f,1,11);
			}
		}

		if(us != 0){										// ANVL鎞
			proc_no_key_timeup(1);							// L[͂L
			if((us & (SWL_ON_CONTINUE | SWL_ON_NOW)) != 0){	// select ꂽ@́@ꑱ
				mi++;
				if(9 < (mi & 0x0f)){						// X𒴂
					mi &= 0xf0;
					mi += 0x10;
				}
				if(0x59 < mi){
					mi = 0;
				}
			}else if((us & (SWR_OFF_SHORT | SWR_OFF_LONG)) != 0){	//  set Zꂽ ́@ꂽ
				if(gRTC_min == mi){							// lύXĂȂ
					r = 0;
				}else{
					gRTC_min = mi;
					rtc_write();							// RTC 
				}
				set_7seg_data(mi >> 4,0,10);
				set_7seg_data(mi & 0x0f,1,11);
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){					// ԃL[͂
			r = 0xff;
			break;
		}

		if(tim_10ms_led == 0){								// Ԍo߂
			if(ucif != 0){									// ԊORM
	 			led_on_off(1);								// kdĉnm
				tim_10ms_led = 10;							// POOr^C}[d|
	 		}else{
				led_on_off(0);
			}
		}

	}

	return(r);
}
//*****************************************
// b킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static unsigned char	proc_set_sec(void)
{
	unsigned char	blk_stat=0;
	unsigned char	se;
	unsigned char	ucif;
	unsigned short	us;
	unsigned char	r=0;

	se = gRTC_sec;
	set_7seg_data(se >> 4,0,12);							// b\
	set_7seg_data(se & 0x0f,0,13);

	tim_10ms_sblink = 0;									// _
	while(1){
		us = get_action_sw();								// XCb`Ԃ
		ucif = get_infrared_data();							// ԊORfqf[^
		if((us & (SWL_MASK | SWR_MASK)) == 0){				// XCb`ĂȂ
			us = trans_if_to_sw(ucif);						// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_sblink == 0){							// _Ń^C~O̎
			tim_10ms_sblink = 50;
			if((blk_stat==0)&&((us & SWL_ON) == 0)){		// ĂȂ ł̎
				blk_stat = 1;
				set_7seg_data(16,0,12);
				set_7seg_data(16,0,13);
			}else{
				blk_stat = 0;
				set_7seg_data(se >> 4,0,12);
				set_7seg_data(se & 0x0f,0,13);
			}
		}

		if(us != 0){										// ANVL鎞
			proc_no_key_timeup(1);							// L[͂L
			if((us & (SWL_ON_CONTINUE | SWL_ON_NOW)) != 0){	// select ꂽ@́@ꑱ
				se++;
				if(9 < (se & 0x0f)){						// X𒴂
					se &= 0xf0;
					se += 0x10;
				}
				if(0x59 < se){
					se = 0;
				}
			}else if((us & (SWR_OFF_SHORT | SWR_OFF_LONG)) != 0){	//  set Zꂽ ́@ꂽ
				if(gRTC_sec == se){							// lύXĂȂ
					r = 0;
				}else{
					gRTC_sec = se;
					rtc_write();							// RTC 
				}
				set_7seg_data(se >> 4,0,12);
				set_7seg_data(se & 0x0f,0,13);
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){					// ԃL[͂
			r = 0xff;
			break;
		}

		if(tim_10ms_led == 0){								// Ԍo߂
			if(ucif != 0){									// ԊORM
	 			led_on_off(1);								// kdĉnm
				tim_10ms_led = 10;							// POOr^C}[d|
	 		}else{
				led_on_off(0);
			}
		}

	}

	return(r);
}
//*****************************************
// v킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
unsigned char	proc_set_rtc(void)
{
	unsigned char	r;

	rtc_read();									// RTC ǂݏo

	gRTC_mon &= 0x1f;							// 
	gRTC_day &= 0x3f;							// 
	gRTC_hou &= 0x3f;							// 
	gRTC_min &= 0x7f;							// 
	gRTC_sec &= 0x7f;							// b

	disp_ymdmhs();								//  킹p̑S̕\

	r = proc_set_year();						// N킹
	if(r == 0){
		r = proc_set_month();					// 킹
		if(r == 0){
			r = proc_set_day();					// 킹
			if(r == 0){
				r = proc_set_hour();			// 킹
				if(r == 0){
					r = proc_set_minute();		// 킹
					if(r == 0){
						r = proc_set_sec();		// b킹
					}
				}
			}
		}
	}
	return(r);
}

